/*
//	File:		SPITest.h
//	Created:	Christian Apfel
//	Date:		01.04.2016
//	Modified:	Christian Apfel
//	Date:		10.08.2016
//
*/

#ifndef SPITEST_H
#define SPITEST_H

#define SPI_WREN_25AA010A 0x00000006
#define SPI_WRDI_25AA010A 0x00000004
#define SPI_WRITE_25AA010A 0x00000002
#define SPI_READ_25AA010A 0x00000003
#define SPI_WRSR_25AA010A 0x00000001
#define SPI_RDSR_25AA010A 0x00000005

#define SPI_DATA_BUFFER_SIZE		32	// Static define Data Buffer Size (recommed to use 32bit)
#define SPI_FLASH_DATA_TYPE_SIZE	8	// Define Flash Data Type Size (25aa010a)
#define SPI_DATA_MASK				0xFFFFFFFF

class SPITest
{
public:
	SPITest();
	~SPITest();
	void StartSpiTest();
	bool SPIWriteTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData);
	bool SPIReadTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData);
	bool SPIWriteFlashTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData);
	bool SPIReadFlashTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData);
	bool SPISetSingleFlashDataBuffer(int iFullBitCount, unsigned long *lOutputData, unsigned long *lOutputDataBuffer);
};

#endif