/*
//	Description: Demo SPI Functions
//	File:		SPITest.cpp
//	Created:	Christian Apfel
//	Date:		01.04.2016
//	Modified:	Christian Apfel
//	Date:		10.08.2016
//
*/

#include "stdafx.h"
#include "SPITest.h"

using namespace std;

SPITest::SPITest()
{

}

SPITest::~SPITest()
{

}

// ****** Demo App Menu Functions ******

void SPITest::StartSpiTest()
{
	int SPI_TEST;
	int SPI_DEV;
	int SPI_DEV_MODE;
	int SPI_DATA_BIT_COUNT;
	int SPI_DATA_BYTE_COUNT;
	int SPI_DATA_ARRAY_COUNT;
	unsigned long SPI_COMMAND_CODE;
	unsigned long SPI_DATA_ARRAY[4];
	unsigned long SPI_REVERSE_DATA_ARRAY[2];
	unsigned long SPI_REVERSE_FLASH_DATA;
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		memset(SPI_DATA_ARRAY, 0, sizeof(SPI_DATA_ARRAY));
		memset(SPI_REVERSE_DATA_ARRAY, 0, sizeof(SPI_REVERSE_DATA_ARRAY));

		cout << "---------------------------------" << endl;
		cout << "Select SPI Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write/Read Exchange Test" << endl;
		cout << "2: Read Exchange Test" << endl;
		cout << "3: Write/Read Loopback Test" << endl;
		cout << "4: Write Flash Test (25aa010a)" << endl;
		cout << "5: Read Flash Test (25aa010a)" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> SPI_TEST;

		switch(SPI_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "SPI Write/Read Exchange Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter SPI Device (1,2): ";
				cin >> SPI_DEV;
				cout << "Enter SPI Mode (0..3): ";
				cin >> SPI_DEV_MODE;
				cout << "Enter SPI Write Data Bitcount (e.g. 1 - 128): ";
				cin >> SPI_DATA_BIT_COUNT;

				// Calculate Data Array Length
				if(SPI_DATA_BIT_COUNT > 32)
				{
					// Calculate Data Array Len
					SPI_DATA_ARRAY_COUNT = (SPI_DATA_BIT_COUNT / 32);

					// If Data Array Len are not full type array
					if((SPI_DATA_BIT_COUNT % 32) != 0)
					{
						SPI_DATA_ARRAY_COUNT = SPI_DATA_ARRAY_COUNT + 1;
					}
				}
				else
				{
					//If data array are less than 32 bit
					SPI_DATA_ARRAY_COUNT = 1;
				}

				for(int i = 0; i < SPI_DATA_ARRAY_COUNT; i++)
				{
					cout << "Enter SPI Data[" << i << "] (e.g. 0x0000ffff): ";
					cin >> SPI_DATA_ARRAY[i];
				}

				if(SPIWriteTest(DHCOM_SPIEnum(SPI_DEV - 1), DHCOM_SPIModeEnum(SPI_DEV_MODE), SPI_DATA_BIT_COUNT, SPI_DATA_ARRAY, SPI_REVERSE_DATA_ARRAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "SPI Write/Read Test is " << cStatus << "!!!" << endl;

				for(int i = 0; i < SPI_DATA_ARRAY_COUNT; i++)
				{
					cout << "Register Value " << i << ": 0x" << std::hex << SPI_REVERSE_DATA_ARRAY[i] << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "SPI Read Exchange Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter SPI Device (1,2): ";
				cin >> SPI_DEV;
				cout << "Enter SPI Mode (0..3): ";
				cin >> SPI_DEV_MODE;
				cout << "Enter SPI Write Data Bitcount (e.g. 1 - 128): ";
				cin >> SPI_DATA_BIT_COUNT;

				// Calculate Data Array Length
				if(SPI_DATA_BIT_COUNT > 32)
				{
					// Calculate Data Array Len
					SPI_DATA_ARRAY_COUNT = (SPI_DATA_BIT_COUNT / 32);

					// If Data Array Len are not full type array
					if((SPI_DATA_BIT_COUNT % 32) != 0)
					{
						SPI_DATA_ARRAY_COUNT = SPI_DATA_ARRAY_COUNT + 1;
					}
				}
				else
				{
					//If data array are less than 32 bit
					SPI_DATA_ARRAY_COUNT = 1;
				}

				if(SPIReadTest(DHCOM_SPIEnum(SPI_DEV - 1), DHCOM_SPIModeEnum(SPI_DEV_MODE), SPI_DATA_BIT_COUNT, SPI_DATA_ARRAY, SPI_REVERSE_DATA_ARRAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "SPI Read Test is " << cStatus << "!!!" << endl;

				for(int i = 0; i < SPI_DATA_ARRAY_COUNT; i++)
				{
					cout << "Register Value " << i << ": 0x" << std::hex << SPI_REVERSE_DATA_ARRAY[i] << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "SPI Write/Read Loopback Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter SPI Device (1,2): ";
				cin >> SPI_DEV;
				cout << "Enter SPI Mode (0..3): ";
				cin >> SPI_DEV_MODE;
				cout << "Enter SPI Write Data Bitcount (e.g. 1 - 128): ";
				cin >> SPI_DATA_BIT_COUNT;

				// Calculate Data Array Length
				if(SPI_DATA_BIT_COUNT > 32)
				{
					// Calculate Data Array Len
					SPI_DATA_ARRAY_COUNT = (SPI_DATA_BIT_COUNT / 32);

					// If Data Array Len are not full type array
					if((SPI_DATA_BIT_COUNT % 32) != 0)
					{
						SPI_DATA_ARRAY_COUNT = SPI_DATA_ARRAY_COUNT + 1;
					}
				}
				else
				{
					//If data array are less than 32 bit
					SPI_DATA_ARRAY_COUNT = 1;
				}

				for(int i = 0; i < SPI_DATA_ARRAY_COUNT; i++)
				{
					cout << "Enter SPI Data[" << i << "] (e.g. 0x0000ffff): ";
					cin >> SPI_DATA_ARRAY[i];
				}

				if(SPIWriteTest(DHCOM_SPIEnum(SPI_DEV - 1), DHCOM_SPIModeEnum(SPI_DEV_MODE), SPI_DATA_BIT_COUNT, SPI_DATA_ARRAY, SPI_REVERSE_DATA_ARRAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "SPI Write/Read Loopback Test is " << cStatus << "!!!" << endl;

				for(int i = 0; i < SPI_DATA_ARRAY_COUNT; i++)
				{
					cout << "Register Value " << i << ": 0x" << std::hex << SPI_REVERSE_DATA_ARRAY[i] << endl;
				}
				cout << "------------------------------------" << endl;
			}
			break;
		case 4:
			{
				cout << endl;
				cout << "Write Flash Test (25aa010a)" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter SPI Device (1,2): ";
				cin >> SPI_DEV;
				cout << "Enter SPI Mode (0..3): ";
				cin >> SPI_DEV_MODE;
				cout << "Enter SPI Instruction Set (e.g. 0x02): ";
				cin >> std::hex >> SPI_DATA_ARRAY[0];
				cout << "Enter SPI Address (e.g. 0xaa): ";
				cin >> std::hex >> SPI_DATA_ARRAY[1];
				cout << "Enter SPI Write Data Bytecount (1 - 2): ";
				cin >> std::dec >> SPI_DATA_BYTE_COUNT;

				if(SPI_DATA_BYTE_COUNT > 2)
				{
					cout << "Byte Count " << SPI_DATA_BYTE_COUNT << " not supported!!!";
				}

				// Calculate Data Bit Length
				SPI_DATA_BIT_COUNT = (SPI_DATA_BYTE_COUNT * SPI_FLASH_DATA_TYPE_SIZE) + (2 * SPI_FLASH_DATA_TYPE_SIZE);

				for(int i = 0; i < (SPI_DATA_BYTE_COUNT); i++)
				{
					cout << "Enter SPI Data[" << i+1 << "] (e.g. 0xaa): ";
					cin >> std::hex >> SPI_DATA_ARRAY[i+2];
				}

				if(SPIWriteFlashTest(DHCOM_SPIEnum(SPI_DEV - 1), DHCOM_SPIModeEnum(SPI_DEV_MODE), SPI_DATA_BIT_COUNT, SPI_DATA_ARRAY, SPI_REVERSE_DATA_ARRAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "SPI Write Flash Test Register Data: 0x" << std::hex << SPI_REVERSE_DATA_ARRAY[0] << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 5:
			{
				cout << endl;
				cout << "Read Flash Test (25aa010a)" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter SPI Device (1,2): ";
				cin >> SPI_DEV;
				cout << "Enter SPI Mode (0..3): ";
				cin >> SPI_DEV_MODE;
				cout << "Enter SPI Instruction Set (e.g. 0x02): ";
				cin >> std::hex >> SPI_DATA_ARRAY[0];
				cout << "Enter SPI Address (e.g. 0xaa): ";
				cin >> std::hex >> SPI_DATA_ARRAY[1];
				cout << "Enter SPI Read Data Bytecount (1 - 2): ";
				cin >> SPI_DATA_BYTE_COUNT;

				// Calculate Data Bit Length
				SPI_DATA_BIT_COUNT = (SPI_DATA_BYTE_COUNT * SPI_FLASH_DATA_TYPE_SIZE) + (2 * SPI_FLASH_DATA_TYPE_SIZE);

				SPI_REVERSE_FLASH_DATA = 0;

				if(SPI_DATA_BYTE_COUNT > 2)
				{
					cout << "Byte Count " << SPI_DATA_BYTE_COUNT << " not supported!!!";
				}

				if(SPIReadFlashTest(DHCOM_SPIEnum(SPI_DEV - 1), DHCOM_SPIModeEnum(SPI_DEV_MODE), SPI_DATA_BIT_COUNT, SPI_DATA_ARRAY, SPI_REVERSE_DATA_ARRAY) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				if(SPI_DATA_BYTE_COUNT > 0)
				{
					SPI_REVERSE_FLASH_DATA = SPI_REVERSE_DATA_ARRAY[0] & (SPI_DATA_MASK >> (SPI_DATA_BUFFER_SIZE - (SPI_DATA_BYTE_COUNT*SPI_FLASH_DATA_TYPE_SIZE)));
				}

				cout << "SPI Read Flash Test Register Data: 0x" << std::hex << SPI_REVERSE_FLASH_DATA <<" is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				return;
			}
			break;
		default:
			{

			}
			break;
		}
	}while(1);
}

// ****** SPI Functions ******

bool SPITest::SPIWriteTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData)
{
	bool bUseDMA = false;
	unsigned int iFreq = 1000000; // 1 Mhz SPI Clockrate

	if(SPIOpen(eSPIPort) == true)
	{
		SPIConfigure(eSPIPort, eSPIMode, iFreq, bUseDMA);

		if(SPIExchange(eSPIPort, iBitCount, lOutputData, lInputData) == true)
		{
			SPIClose(eSPIPort);
			return true;
		}

		SPIClose(eSPIPort);
	}

	return false;
}

bool SPITest::SPIReadTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData)
{
	bool bUseDMA = false;
	unsigned int iFreq = 1000000; // 1 Mhz SPI Clockrate

	if(SPIOpen(eSPIPort) == true)
	{
		SPIConfigure(eSPIPort, eSPIMode, iFreq, bUseDMA);

		if(SPIExchange(eSPIPort, iBitCount, lOutputData, lInputData) == true)
		{
			SPIClose(eSPIPort);
			return true;
		}

		SPIClose(eSPIPort);
	}

	return false;
}

bool SPITest::SPIWriteFlashTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData)
{
	bool bUseDMA = false;
	unsigned int iFreq = 1000000; // 1 Mhz SPI Clockrate
	unsigned long lOutputBufferData[16];

	unsigned long lSetInstruction = 0;
	unsigned long lGetResult = 0;

	unsigned long lRegAddress = 0;

	memset(lOutputBufferData, 0, sizeof(lOutputBufferData));

	if(SPIOpen(eSPIPort) == true)
	{
		SPIConfigure(eSPIPort, eSPIMode, iFreq, bUseDMA);

		//**************************************
		// Set enable write latch bit
		lSetInstruction = SPI_WREN_25AA010A;

		if(SPIExchange(eSPIPort, SPI_FLASH_DATA_TYPE_SIZE, &lSetInstruction, &lGetResult) == false)
		{
			SPIClose(eSPIPort);
			return false;
		}

		//**************************************
		// Set Flash Output Buffer
		SPISetSingleFlashDataBuffer(iBitCount, lOutputData, lOutputBufferData);
		
		//**************************************
		// Write data to flash register
		if(SPIExchange(eSPIPort, iBitCount, lOutputBufferData, lInputData) == false)
		{
			SPIClose(eSPIPort);
			return false;
		}

		//**************************************
		// Set disable write latch bit
		lSetInstruction = SPI_WRDI_25AA010A;
		lGetResult = 0;

		if(SPIExchange(eSPIPort, SPI_FLASH_DATA_TYPE_SIZE, &lSetInstruction, &lGetResult) == false)
		{
			SPIClose(eSPIPort);
			return false;
		}

		SPIClose(eSPIPort);
	}

	return true;
}

bool SPITest::SPIReadFlashTest(DHCOM_SPIEnum eSPIPort, DHCOM_SPIModeEnum eSPIMode, int iBitCount, unsigned long *lOutputData, unsigned long *lInputData)
{
	bool bUseDMA = false;
	unsigned int iFreq = 1000000; // 1 Mhz SPI Clockrate
	unsigned long lOutputBufferData[16];

	unsigned long lRegAddress = 0;

	unsigned long lSetInstruction = 0;

	memset(lOutputBufferData, 0, sizeof(lOutputBufferData));

	if(SPIOpen(eSPIPort) == true)
	{
		SPIConfigure(eSPIPort, eSPIMode, iFreq, bUseDMA);


		//**************************************
		// Set Flash Output Buffer
		//**************************************
		// Set Flash Output Buffer
		SPISetSingleFlashDataBuffer(iBitCount, lOutputData, lOutputBufferData);

		//**************************************
		// Read data from flash register
		if(SPIExchange(eSPIPort, iBitCount, lOutputBufferData, lInputData) == true)
		{
			SPIClose(eSPIPort);
			return true;
		}

		SPIClose(eSPIPort);
	}

	return false;
}

bool SPITest::SPISetSingleFlashDataBuffer(int iFullBitCount, unsigned long *lOutputData, unsigned long *lOutputBufferData)
{
	int iDataTypeCount = 0;
	int iDataBitShiftCount = 0;
	int iFirstDataBitShiftCount = 0;

	//**************************************
	// Set Data Bit Shift Count
	iDataBitShiftCount = (iFullBitCount % SPI_DATA_BUFFER_SIZE);
	iFirstDataBitShiftCount = (iFullBitCount % SPI_FLASH_DATA_TYPE_SIZE);

	iDataTypeCount = iFullBitCount / SPI_FLASH_DATA_TYPE_SIZE;

	if(iFirstDataBitShiftCount != 0)
	{
		iDataTypeCount++;
	}

	//**************************************
	// Set Output Buffer
	if(iDataTypeCount == 3)
	{
		// if 24 bit should written
		lOutputBufferData[0] = lOutputBufferData[0] | *lOutputData << (SPI_FLASH_DATA_TYPE_SIZE*2);
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+1) << (SPI_FLASH_DATA_TYPE_SIZE);
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+2);
	}
	else if(iDataTypeCount == 2)
	{
		// if 16 bit should written
		lOutputBufferData[0] = lOutputBufferData[0] | *lOutputData << SPI_FLASH_DATA_TYPE_SIZE;
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+1);
	}
	else if(iDataTypeCount == 1)
	{
		// if 8 bit should written
		lOutputBufferData[0] = lOutputBufferData[0] | *lOutputData;
	}
	else
	{
		// if all 32 bit should written
		lOutputBufferData[0] = lOutputBufferData[0] | *lOutputData << (SPI_FLASH_DATA_TYPE_SIZE*3);
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+1) << (SPI_FLASH_DATA_TYPE_SIZE*2);
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+2) << SPI_FLASH_DATA_TYPE_SIZE;
		lOutputBufferData[0] = lOutputBufferData[0] | *(lOutputData+3);
	}

	return true;
}

